ALTER TABLE PRINT_MODULI
ADD MODULE_TYPE VARCHAR2(3 CHAR);

CREATE TABLE PRINT_MODULE_TYPE (
  CODE VARCHAR2(3 CHAR) NOT NULL,
  DESCRIPTION VARCHAR2(100 CHAR),
  INTERNAL_DESCRIPTION VARCHAR2(100 CHAR),
  CONSTRAINT PRINT_MODULE_TYPE_PK PRIMARY KEY (CODE)
);

INSERT INTO PRINT_MODULE_TYPE(CODE, DESCRIPTION, INTERNAL_DESCRIPTION) VALUES
('QST', 'Questionnaire', 'Questionnaire');

CREATE OR REPLACE VIEW V_PRINT_MODULI AS (
  SELECT P.MODULE_ID, P.OPIS, P.INTERNI_OPIS, P.CR_FILE, P.ID_EMAIL_TEMPLATE, P.MODULE_TYPE,
  ET.NAME AS EMAIL_TEMPLATE_NAME, PMT.DESCRIPTION AS MODULE_TYPE_DESCRIPTION
	FROM PRINT_MODULI P
  LEFT OUTER JOIN EMAIL_TEMPLATE ET ON ET.ID_EMAIL_TEMPLATE = P.ID_EMAIL_TEMPLATE
  LEFT OUTER JOIN PRINT_MODULE_TYPE PMT ON PMT.CODE = P.MODULE_TYPE
);

INSERT INTO QUESTIONNAIRE_TYPE(ID, OPIS, INTERNI_OPIS, ACT) 
VALUES (6, 'Boat', 'Boat', 'Y');

INSERT INTO QUESTIONNAIRE_TYPE(ID, OPIS, INTERNI_OPIS, ACT) 
VALUES (7, 'Work order', 'Work order', 'Y');

ALTER TABLE QUESTIONNAIRE
ADD ID_PRINT_MODULE VARCHAR2(20 CHAR);

ALTER TABLE QUESTIONNAIRE_ANSWER_MASTER
ADD ID_DN NUMBER;

CREATE OR REPLACE VIEW V_QUESTIONNAIRE_ANSWER_MASTER AS (
	SELECT QAM.ID, QAM.ID_MARINA_EVENT, QAM.ID_QUESTIONNAIRE, QAM.STATUS, QAM.ID_LASTNIKA, QAM.ID_PLOVILA, QAM.DATE_CREATED, QAM.ID_DN,
  QU.NAME AS QUESTIONNAIRE_NAME, QU.TYPE AS QUESTIONNAIRE_TYPE, QU.ID_PRINT_MODULE AS QUESTIONNAIRE_ID_PRINT_MODULE
	FROM QUESTIONNAIRE_ANSWER_MASTER QAM
  LEFT OUTER JOIN QUESTIONNAIRE QU ON QU.ID = QAM.ID_QUESTIONNAIRE
);

ALTER TABLE NPRIKLJ
ADD COLOR VARCHAR2(20 CHAR);


insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1328, SYSDATE, '5.5', 1248, 'Questionnaire print')
;