ALTER TABLE M_NNSTOMAR
ADD SORT NUMBER;

ALTER TABLE M_STORITVE
ADD SORT NUMBER;

ALTER TABLE M_VZORCI_PS
ADD SORT NUMBER;

CREATE OR REPLACE VIEW V_STORITVE AS (
	SELECT M.ID_STORITVE, M.ID_DN, M.ID_POGODBE, M.ID_VPS, M.VRSTA, M.ID_LASTNIKA, M.ID_PLOVILA, M.STORITEV, M.KAT, M.TIMEKAT, M.PROCKAT, M.DATUM_OD, M.DATUM_DO, M.KOLICINA, M.POPUST, M.OPIS_SERVIS,
  M.ZNESEK, M.VALUTA, M.TECAJ, M.DAVEK, M.N_PONUDBE, M.N_RACUNA, M.DATUM_RACUNA, M.ZAKLJUCEN, M.KOMENTAR, M.DATUM_KREIRANJA, M.USER_KREIRANJA, M.DATUM_SPREMEMBE, M.USER_SPREMEMBE, M.TIP_SERVIS, M.AUTO,
  M.POPUST1, M.POPUST2, M.NAMENP, M.NAMENP1, M.NAMENP2, M.TECAJP, M.DODATNA_STORITEV, M.DOMACA_VALUTA, M.PROVIZIJA, M.DRZAVA, M.SKUPAJ_OSEB, M.ID_KAT, M.PROVIZIJA_DELITEV, M.ID_REZERVACIJE, M.CUSTOM,
  M.CPROVIZIJA, M.SERVICE_COST, M.COMPLETE, M.KOLICINA_INSTR, M.ID_STORITVE_GEN, M.ID_BATCH, M.ID_SALDKONT, M.ID_LASTNIKA_ORG, M.NNLOCATION_ID, M.MIN_FEE, M.ID_LASTNIK_LEASE, 
  M.NCARD, M.FULL_AMOUNT, M.SERVICE_TIME, M.ID_PRIVEZ, M.SUBLEASE_PAYMENT, M.ID_DAVEK, M.LASTNIK_LEASE_PROCENT, M.ID_REZERVACIJE_CHARTER, M.ID_SERVICE_TEMPLATE, M.CAS_OD, M.CAS_DO, M.USER_COMMENT, M.SERVICE_COMMENT,
  M.ID_OWNER_SIGNATURE, M.ID_NAJAVE, M.SORT,
  NS.OPIS AS NNSTOMAR_OPIS, NS.INTERNI_OPIS AS NNSTOMAR_INTERNI_OPIS, NS.DAVEK AS NNSTOMAR_DAVEK, NS.KAT AS NNSTOMAR_KAT, NS.TIMEKAT AS NNSTOMAR_TIMEKAT, NS.ENOTA AS NNSTOMAR_ENOTA, NS.FILTER AS NNSTOMAR_FILTER,
  NS.DEPARTURE_CHECK AS NNSTOMAR_DEPARTURE_CHECK, NS.NIGHTS_PRICE AS NNSTOMAR_NIGHTS_PRICE,
  NNE.OPIS AS NNSTOMAR_ENOTA_OPIS, NNE.INTERNI_OPIS AS NNSTOMAR_ENOTA_INTERNI_OPIS, MDN.DATUM_DN AS M_DE_NA_DATUM_DN, MDN.TERMIN_DO AS M_DE_NA_TERMIN_DO, MDN.STEVILKA AS M_DE_NA_STEVILKA,
  MDN.STATUS AS M_DE_NA_STATUS, MDN.ORG_STATUS AS M_DE_NA_ORG_STATUS, 
  KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK, KU.MANAGER AS KUPCI_MANAGER, KU.VRSTA AS KUPCI_VRSTA, PL.IME AS PLOVILA_IME,
  
  -- Service values
  SV.NETO_DOMACA_VREDNOST,
  SV.NETO_DOMACA_VREDNOST + (SV.NETO_DOMACA_VREDNOST * (NVL(M.DAVEK, 0) / 100)) AS BRUTO_DOMACA_VREDNOST,
  SV.NETO_DOMACA_VREDNOST / (SELECT NVL(LAST_MIDDLE_RATE, 1) FROM V_FOREIGN_RATE) AS NETO_TUJA_VREDNOST,
  (SV.NETO_DOMACA_VREDNOST + (SV.NETO_DOMACA_VREDNOST * (NVL(M.DAVEK, 0) / 100))) / (SELECT NVL(LAST_MIDDLE_RATE, 1) FROM V_FOREIGN_RATE) AS BRUTO_TUJA_VREDNOST
  
	FROM M_STORITVE M
  LEFT OUTER JOIN V_STORITVE_VALUE SV ON SV.ID_STORITVE = M.ID_STORITVE
  LEFT OUTER JOIN M_NNSTOMAR NS ON NS.SIFRA = M.STORITEV
  LEFT OUTER JOIN NNENOTE NNE ON NNE.SIFRA = NS.ENOTA
  LEFT OUTER JOIN M_DE_NA MDN ON MDN.ID_DN = M.ID_DN
  LEFT OUTER JOIN KUPCI KU ON KU.ID = M.ID_LASTNIKA
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = M.ID_PLOVILA
);

CREATE OR REPLACE VIEW V_M_VZORCI_PS AS (
  SELECT M.ID, M.LETO, M.ID1, M.STORITEV, M.KAT, M.TIMEKAT, M.PROCKAT, M.DATUM_ZACETKA, M.DATUM_KONCA, M.ID_VPS, M.ID_POGODBE, M.SKUPAJ, M.DATUM_OBRACUNA, M.OBRACUNANO, M.POPUST, M.DAVEK, M.KOLICINA, M.POPUST1, M.POPUST2, M.KOMENTAR, M.DOMACA_VALUTA,
  M.PROVIZIJA, M.TECAJ, M.STORNO, M.AUTO, M.DODATNA_STORITEV, M.DATUM_PONUDBE, M.KOLICINA_INSTR, M.ZAPOREDJE, M.AUTO_CREATE_METHOD, M.AUTO_CREATE_DAY, M.NEXT_AUTO_DATE, M.ACTIVE, M.AMOUNT_DAY, M.AMOUNT_MONTH, M.NAMENP, M.NAMENP1, M.NAMENP2, M.ID_PRIVEZ,
  M.DATUM_KREIRANJA, M.DATUM_SPREMEMBE, M.USER_KREIRANJA, M.USER_SPREMEMBE, M.ID_DAVEK, M.USER_COMMENT, M.SERVICE_COMMENT, M.FULL_AMOUNT, M.SORT,
  NS.OPIS AS NNSTOMAR_OPIS, NS.INTERNI_OPIS AS NNSTOMAR_INTERNI_OPIS, NS.DAVEK AS NNSTOMAR_DAVEK, NS.KAT AS NNSTOMAR_KAT, NS.TIMEKAT AS NNSTOMAR_TIMEKAT, NS.ENOTA AS NNSTOMAR_ENOTA, NS.FILTER AS NNSTOMAR_FILTER
  FROM M_VZORCI_PS M
  LEFT OUTER JOIN M_NNSTOMAR NS ON NS.SIFRA = M.STORITEV
);

CREATE OR REPLACE VIEW V_KUPCI AS (
	SELECT K.ID, K.ID_MEMBER, K.IME, K.PRIIMEK, K.MESTO, K.NASLOV, K.POSTA, K.TELEFON_1, K.TELEFON_2, K.EMAIL, K.YACHT_CLUB_ID, K.TELEX, K.VRSTA, K.NDRZAVA, 
	K.SALDAKONTI_SIT, K.SALDAKONTI_DEM, K.SALDAKONTI_KOM, K.BELEZKA, K.MANAGER, K.ACT, K.KODA_JEZIKA,
  ENQ.INITIAL_CONTACT_DATE, ENQ.SELL_PHASE, ENQ.BOAT_LOCATION_ID,
	NNTIT.INTERNI_OPIS AS NNTITLE_DESC, NNDRZ.INTERNI_OPIS AS NNDRZAVA_DESC, NNDOK.INTERNI_OPIS AS VRSTA_DOKUMENTA_DESC, NNVRS.INTERNI_OPIS AS VRSTA_DESC,
	NNDRZDR.INTERNI_OPIS AS DRZAVA_ROJSTVA_DESC, NNDRZCI.INTERNI_OPIS AS CITIZENSHIP_DESC, NNMAR.INTERNI_OPIS AS MARITAL_STATUS_DESC, NNUSR.USER_ AS MANAGER_USER,
  NSP.OPIS AS SELL_PHASE_OPIS, NNLB.OPIS AS BOAT_LOCATION_OPIS,
  (SELECT LISTAGG(NV.OPIS,', ') WITHIN GROUP(ORDER BY NV.OPIS ASC) TYPES FROM KUPCI_VRSTA KV, NNVRSKUP NV WHERE NV.SIFRA = KV.VRSTA AND KV.ID_KUPCA = K.ID) AS TYPES_DESCRIPTIONS
	FROM KUPCI K
	LEFT OUTER JOIN NNTITLE NNTIT ON K.NTITLE = NNTIT.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZ ON K.NDRZAVA = NNDRZ.SIFRA
	LEFT OUTER JOIN NNDOKUME NNDOK ON K.VRSTA_DOKUMENTA = NNDOK.SIFRA
	LEFT OUTER JOIN NNVRSKUP NNVRS ON K.VRSTA = NNVRS.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZDR ON K.DRZAVA_ROJSTVA = NNDRZDR.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZCI ON K.CITIZENSHIP = NNDRZCI.SIFRA
	LEFT OUTER JOIN NNMARSTAT NNMAR ON K.MARITAL_STATUS = NNMAR.SIFRA
  LEFT OUTER JOIN NUSER NNUSR ON K.MANAGER = NNUSR.NUSER
  LEFT OUTER JOIN ENQUIRY ENQ ON K.ID = ENQ.ID_KUPCA
  LEFT OUTER JOIN NNSELL_PHASE NSP ON ENQ.SELL_PHASE = NSP.SIFRA
  LEFT OUTER JOIN NNLOCATION NNLB ON ENQ.BOAT_LOCATION_ID = NNLB.ID
);

CREATE OR REPLACE VIEW V_KUPCIBELEZKE AS (
SELECT KB.ID_KPBELEZKE, KB.IDKUPCA, KB.DATUMKREIRANJA, KB.USERKREIRANJA, KB.BELEZKA, KB.VELJAVNA, KB.TYPE, KB.SUBTYPE,
KBT.OPIS AS BELEZKE_TYPE_OPIS, KBT.INTERNI_OPIS AS BELEZKE_TYPE_INTERNI_OPIS, KBS.OPIS AS BELEZKE_SUBTYPE_OPIS, KBS.INTERNI_OPIS AS BELEZKE_SUBTYPE_INTERNI_OPIS,
K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.MANAGER AS KUPCI_MANAGER, K.VRSTA AS KUPCI_VRSTA, K.NDRZAVA AS KUPCI_NDRZAVA, K.KODA_JEZIKA AS KUPCI_KODA_JEZIKA
FROM KUPCIBELEZKE KB
LEFT OUTER JOIN NKUPCIBELEZKE_TYPE KBT ON KBT.ID = KB.TYPE
LEFT OUTER JOIN NKUPCIBELEZKE_SUBTYPE KBS ON KBS.ID = KB.SUBTYPE
LEFT OUTER JOIN KUPCI K ON K.ID = KB.IDKUPCA
);

CREATE OR REPLACE VIEW V_KUPCI_ACTIVITY
AS (
SELECT KA.ID_KUPCI_ACTIVITY, K.ID AS KUPCI_ID, K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.MANAGER AS KUPCI_MANAGER, 
K.VRSTA AS KUPCI_VRSTA, K.NDRZAVA AS KUPCI_NDRZAVA, K.KODA_JEZIKA AS KUPCI_KODA_JEZIKA,
A.ID_ACTIVITY AS ID_ACTIVITY, A.DATE_FROM AS ACTIVITY_DATE_FROM, A.DATE_TO AS ACTIVITY_DATE_TO, A.ACTIVITY_TYPE, A.DESCRIPTION AS ACTIVITY_DESCRIPTION, A.STATUS AS ACTIVITY_STATUS,
A.DATE_CREATED AS ACTIVITY_DATE_CREATED, A.USER_CREATED AS ACTIVITY_USER_CREATED, A.DATE_CHANGED AS ACTIVITY_DATE_CHANGED, A.USER_CHANGED AS ACTIVITY_USER_CHANGED, A.COMPLETED AS ACTIVITY_COMPLETED, 
A.AUTO_CREATE AS ACTIVITY_AUTO_CREATE, A.SOURCE AS ACTIVITY_SOURCE, AT.OPIS AS ACTIVITY_TYPE_OPIS, AT.INTERNI_OPIS AS ACTIVITY_TYPE_INTERNI_OPIS, AT.AKT AS ACTIVITY_TYPE_AKT
FROM KUPCI_ACTIVITY KA
JOIN KUPCI K ON K.ID = KA.ID_KUPCA
JOIN ACTIVITY A ON A.ID_ACTIVITY = KA.ID_ACTIVITY
LEFT OUTER JOIN NNACTIVITY_TYPE AT ON AT.ID_NNACTIVITY_TYPE = A.ACTIVITY_TYPE
);

CREATE OR REPLACE VIEW V_ALARM_RECEIVE AS (
	SELECT ARD.ID_ALARM_RECIEVE_DET AS ID, ARD.ID_ALARM_RECIEVE_DET, ARD.ID_ALARM_RECIEVE, ARD.USER_RECIEVE, ARD.DATE_RECIEVE, AR.ID_ALARM, AR.RECIEVE_TYPE, AR.RECIEVE_DATA, 
  REGEXP_REPLACE(AR.RECIEVE_DATA, '^[;]') AS RECIEVE_DATA_BEAUTIFIED,
  AD.SFALARM, AD.SFMODULE, AD.DATUM_KREIRANJA, AD.USER_KREIRANJA, AD.DATUM_ZAPADLOST, AD.SFTRIGGER, AD.USER_MESSAGE, AD.ASOCIATED_TABLE, AD.NNLOCATION_ID,
  AD.ASOCIATED_DATA, AD.STATUS, AD.DATA_CHECK, (CASE WHEN ARD.DATE_RECIEVE IS NULL THEN 'Y' ELSE 'N' END) AS UNCONFIRMED, 
  K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.NDRZAVA AS KUPCI_NDRZAVA, K.KODA_JEZIKA AS KUPCI_KODA_JEZIKA,
  P.ID AS PLOVILA_ID, P.IME AS PLOVILA_IME, 
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
  FROM ALARM_RECIEVE_DETAIL ARD
  INNER JOIN ALARM_RECIEVE AR ON AR.ID_ALARM_RECIEVE = ARD.ID_ALARM_RECIEVE
  INNER JOIN ALARM_DATA AD ON AD.ID_ALARM = AR.ID_ALARM
  LEFT OUTER JOIN KUPCI K ON K.ID = AD.ASOCIATED_DATA AND AD.ASOCIATED_TABLE = 'KUPCI'
  LEFT OUTER JOIN PLOVILA P ON P.ID = AD.ASOCIATED_DATA AND AD.ASOCIATED_TABLE = 'PLOVILA'
  UNION ALL
  SELECT ARD.ID_ALARM_RECIEVE_DET AS ID, ARD.ID_ALARM_RECIEVE_DET, ARD.ID_ALARM_RECIEVE, ARD.USER_RECIEVE, ARD.DATE_RECIEVE, AR.ID_ALARM, AR.RECIEVE_TYPE, AR.RECIEVE_DATA, 
  REGEXP_REPLACE(AR.RECIEVE_DATA, '^[;]') AS RECIEVE_DATA_BEAUTIFIED,
  AH.SFALARM, AH.SFMODULE, AH.DATUM_KREIRANJA, AH.USER_KREIRANJA, AH.DATUM_ZAPADLOST, AH.SFTRIGGER, AH.USER_MESSAGE, AH.ASOCIATED_TABLE, AH.NNLOCATION_ID,
  AH.ASOCIATED_DATA, AH.STATUS, AH.DATA_CHECK, 'N' AS UNCONFIRMED, 
  K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.NDRZAVA AS KUPCI_NDRZAVA, K.KODA_JEZIKA AS KUPCI_KODA_JEZIKA,
  P.ID AS PLOVILA_ID, P.IME AS PLOVILA_IME,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
  FROM ALARM_RECIEVE_DETAIL ARD
  INNER JOIN ALARM_RECIEVE AR ON AR.ID_ALARM_RECIEVE = ARD.ID_ALARM_RECIEVE
  INNER JOIN ALARM_HISTORY AH ON AH.ID_ALARM = AR.ID_ALARM
  LEFT OUTER JOIN KUPCI K ON K.ID = AH.ASOCIATED_DATA AND AH.ASOCIATED_TABLE = 'KUPCI'
  LEFT OUTER JOIN PLOVILA P ON P.ID = AH.ASOCIATED_DATA AND AH.ASOCIATED_TABLE = 'PLOVILA'
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1332, SYSDATE, '5.5', 1252, 'Service sort')
;