DROP VIEW V_REZERVAC;

CREATE OR REPLACE VIEW V_REZERVAC AS (
SELECT R.ID, 0 AS PRISOTNO, R.DATUM_REZERVACIJE, R.DATUM_DO, R.ID_LASTNIKA, R.ID_PLOVILA, 0 AS ID_PRESPR, R.NAZIV, R.PLOVILO, NP.OBJEKT AS NOBJEKT, NP.N_PRIVEZA AS PRIVEZ, NP.ID_PRIVEZ
, R.DOLZINA, R.SIRINA, R.GREZ, '' AS NTIP 
FROM REZERVAC R 
LEFT OUTER JOIN NNPRIVEZ NP ON R.NOBJEKT=NP.OBJEKT AND R.PRIVEZ=NP.N_PRIVEZA 
WHERE R.STORNO IS NULL AND R.DATUM_DO IS NOT NULL
UNION ALL
SELECT 0 as ID, (CASE WHEN T.ID_PRIVEZ=PR.ID_PRIVEZ THEN 1 ELSE 0 END) AS PRISOTNO, 
(CASE WHEN T.ID_PRIVEZ=PR.ID_PRIVEZ THEN NVL(P.TRENUTNO_DO, TRUNC(SYSDATE)) ELSE TRUNC(SYSDATE+1) END) AS DATUM_REZERVACIJE, 
NVL(POG.DATUM_KONCA, TRUNC(SYSDATE)+365) AS DATUM_DO, 
POG.ID_LASTNIKA, POG.ID_PLOVILA, 0 AS ID_PRESPR, K.PRIIMEK AS NAZIV, P.IME AS PLOVILO, NP.OBJEKT AS NOBJEKT, NP.N_PRIVEZA AS PRIVEZ, NP.ID_PRIVEZ 
, P.DOLZINA, P.SIRINA, P.GREZ, P.NTIP 
FROM M_POGODBE POG 
JOIN PRIVEZI PR ON PR.ID_POGODBE=POG.ID_POGODBE
JOIN PLOVILA P ON POG.ID_PLOVILA=P.ID
JOIN KUPCI K ON POG.ID_LASTNIKA=K.ID 
LEFT OUTER JOIN NNPRIVEZ NP ON PR.ID_PRIVEZ=NP.ID_PRIVEZ 
LEFT OUTER JOIN PRIVEZI T ON T.ID_PLOVILA=POG.ID_PLOVILA AND T.ID_POGODBE IS NULL AND T.ID_PRIVEZ=PR.ID_PRIVEZ
WHERE POG.STATUS IN ('O', 'A')
UNION ALL
SELECT 0 as ID, 1 AS PRISOTNO, TRUNC(SYSDATE) AS DATUM_REZERVACIJE, 
TRUNC(SYSDATE) AS DATUM_DO, 
POG.ID_LASTNIKA, POG.ID_PLOVILA, 0 AS ID_PRESPR, K.PRIIMEK AS NAZIV, P.IME AS PLOVILO, NP.OBJEKT AS NOBJEKT, NP.N_PRIVEZA AS PRIVEZ, NP.ID_PRIVEZ 
, P.DOLZINA, P.SIRINA, P.GREZ, P.NTIP 
FROM M_POGODBE POG 
JOIN PRIVEZI PR ON PR.ID_POGODBE=POG.ID_POGODBE
JOIN PLOVILA P ON POG.ID_PLOVILA=P.ID
JOIN KUPCI K ON POG.ID_LASTNIKA=K.ID 
JOIN PRIVEZI T ON T.ID_PLOVILA=POG.ID_PLOVILA AND T.ID_POGODBE IS NULL AND T.ID_PRIVEZ<>PR.ID_PRIVEZ
JOIN NNPRIVEZ NP ON T.ID_PRIVEZ=NP.ID_PRIVEZ 
WHERE POG.STATUS IN ('O', 'A') AND ((P.TRENUTNI_OBJEKT_PRIVEZA<>P.POGODBENI_OBJEKT_PRIVEZA) OR (P.TRENUTNA_N_PRIVEZA<>P.POGODBENA_N_PRIVEZA))
UNION ALL
SELECT -1 as ID, 1 AS PRISOTNO, TRUNC(SYSDATE) AS DATUM_REZERVACIJE, 
(CASE WHEN P.TRENUTNO_DO>TRUNC(SYSDATE) THEN P.TRENUTNO_DO ELSE TRUNC(SYSDATE) END) AS DATUM_DO, 
P.ID_LASTNIKA, P.ID AS ID_PLOVILA, 0 AS ID_PRESPR, K.PRIIMEK AS NAZIV, P.IME AS PLOVILO, NP.OBJEKT AS NOBJEKT, NP.N_PRIVEZA AS PRIVEZ, NP.ID_PRIVEZ
, P.DOLZINA, P.SIRINA, P.GREZ, P.NTIP 
FROM PLOVILA P 
JOIN PRIVEZI PR ON PR.ID_PLOVILA=P.ID
JOIN KUPCI K ON P.ID_LASTNIKA=K.ID
LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ=PR.ID_PRIVEZ 
WHERE (PR.ID_POGODBE IS NULL) AND 
(P.ID NOT IN (SELECT ID_PLOVILA FROM M_POGODBE WHERE (STATUS IN ('O', 'A')) AND (ID_PLOVILA IS NOT NULL)))
UNION ALL
SELECT -2 AS ID, 1 AS PRISOTNO, TRUNC(SYSDATE) AS DATUM_REZERVACIJE, TRUNC(SYSDATE) AS DATUM_DO, 0 AS ID_LASTNIKA, 0 AS ID_PLOVILA, P.ID AS ID_PRESPR, 
P.PRIIMEK AS NAZIV, P.IME_PLOVILA AS PLOVILO, PR.OBJEKT AS NOBJEKT, PR.N_PRIVEZA AS PRIVEZ, PR.ID_PRIVEZ AS ID_PRIVEZ, P.DOLZINA AS DOLZINA, NULL AS SIRINA, NULL AS GREZ, P.NTIP AS NTIP
FROM PRESPR P
JOIN PRESPR_PRIVEZI PR ON PR.ID_PRESPR = P.ID
WHERE (P.STATUS = 'N') AND (P.TIP_DOG = 'PT')
);

INSERT INTO NRIGHTS (PRAVICA, KOMENTAR, KOMENTAR_TUJ, INTERNI_OPIS) 
VALUES 
('PROFORMA', 'Proforma invice', 'Proforma invoice', 'Proforma invoice');

insert into verzije_baza (id, dt_vpis, verzija, ver_nr, opis) 
values 
(332, SYSDATE, '5.5', 252, 'Pravice in view rezervacije');